searchNodes=[{"doc":"This library is an implementation of Redlock (Redis destributed lock)RedlockUsageresource = &quot;example_key:\#{user_id}&quot; lock_exp_sec = 10 case Redlock.lock(resource, lock_exp_sec) do {:ok, mutex} -&gt; # some other code which write and read on RDBMS, KVS or other storage # call unlock finally Redlock.unlock(resource, mutex) :error -&gt; Logger.error &quot;failed to lock resource. maybe redis connection got trouble.&quot; {:error, :system_error} endOr you can use transaction functiondef my_function() do # do something, and return {:ok, :my_result} or {:error, :my_error} end def execute_with_lock() do resource = &quot;example_key:\#{user_id}&quot; lock_exp_sec = 10 case Redlock.transaction(resource, lock_exp_sec, &amp;my_function/0) do {:ok, :my_result} -&gt; Logger.info &quot;this is the return-value of my_function/0&quot; :ok {:error, :my_error} -&gt; Logger.info &quot;this is the return-value of my_function/0&quot; :error {:error, :lock_failure} -&gt; Logger.info &quot;if locking has failed, Redlock returns this error&quot; :error end endSetupchildren = [ # other workers/supervisors {Redlock, redlock_opts} ] Supervisor.start_link(children, strategy: :one_for_one)OptionsSingle Node Modereadlock_opts = [ pool_size: 2, drift_factor: 0.01, max_retry: 3, retry_interval_base: 300, retry_interval_max: 3_000, reconnection_interval_base: 500, reconnection_interval_max: 5_000, # you must set odd number of server servers: [ [host: &quot;redis1.example.com&quot;, port: 6379], [host: &quot;redis2.example.com&quot;, port: 6379], [host: &quot;redis3.example.com&quot;, port: 6379] ] ]pool_size: pool_size of number of connection pool for each Redis master node, default is 2drift_factor: number used for calculating validity for results, see https://redis.io/topics/distlock for more detail.max_retry: how many times you want to retry if you failed to lock resource.retry_interval_max: (milliseconds) used to decide how long you want to wait untill your next try after a lock-failure.retry_interval_base: (milliseconds) used to decide how long you want to wait untill your next try after a lock-failure.reconnection_interval_base: (milliseconds) used to decide how long you want to wait until your next try after a redis-disconnectionreconnection_interval_max: (milliseconds) used to decide how long you want to wait until your next try after a redis-disconnectionservers: host, port and auth settings for each redis-server. this amount must be odd. Auth can be omitted if no authentication is reaquiredHow long you want to wait until your next try after a redis-disconnection or lock-failurethe interval(milliseconds) is decided by following calculation.min(XXX_interval_max, (XXX_interval_base (attempts_count * 2)))Cluster Modereadlock_opts = [ pool_size: 2, drift_factor: 0.01, max_retry: 3, retry_interval_base: 300, retry_interval_max: 3_000, reconnection_interval_base: 500, reconnection_interval_max: 5_000, cluster: [ # first node [ # you must set odd number of server [host: &quot;redis1.example.com&quot;, port: 6379], [host: &quot;redis2.example.com&quot;, port: 6379], [host: &quot;redis3.example.com&quot;, port: 6379] ], # second node [ # you must set odd number of server [host: &quot;redis4.example.com&quot;, port: 6379], [host: &quot;redis5.example.com&quot;, port: 6379], [host: &quot;redis6.example.com&quot;, port: 6379] ], # third node [ # you must set odd number of server [host: &quot;redis7.example.com&quot;, port: 6379], [host: &quot;redis8.example.com&quot;, port: 6379], [host: &quot;redis9.example.com&quot;, port: 6379] ] ] ]Set cluster option instead of servers, then Redlock works as cluster mode. When you want to lock some resource, Redlock chooses a node depends on a resource key with consistent-hashing.","ref":"Redlock.html","title":"Redlock","type":"module"},{"doc":"","ref":"Redlock.html#child_spec/1","title":"Redlock.child_spec/1","type":"function"},{"doc":"","ref":"Redlock.html#lock/2","title":"Redlock.lock/2","type":"function"},{"doc":"","ref":"Redlock.html#transaction/3","title":"Redlock.transaction/3","type":"function"},{"doc":"","ref":"Redlock.html#unlock/2","title":"Redlock.unlock/2","type":"function"},{"doc":"","ref":"Redlock.Command.html","title":"Redlock.Command","type":"module"},{"doc":"","ref":"Redlock.Command.html#helper_hash/0","title":"Redlock.Command.helper_hash/0","type":"function"},{"doc":"","ref":"Redlock.Command.html#install_script/1","title":"Redlock.Command.install_script/1","type":"function"},{"doc":"","ref":"Redlock.Command.html#lock/4","title":"Redlock.Command.lock/4","type":"function"},{"doc":"","ref":"Redlock.Command.html#unlock/3","title":"Redlock.Command.unlock/3","type":"function"},{"doc":"","ref":"Redlock.ConnectionKeeper.html","title":"Redlock.ConnectionKeeper","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Redlock.ConnectionKeeper.html#child_spec/1","title":"Redlock.ConnectionKeeper.child_spec/1","type":"function"},{"doc":"","ref":"Redlock.ConnectionKeeper.html#connection/1","title":"Redlock.ConnectionKeeper.connection/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Redlock.ConnectionKeeper.html#init/1","title":"Redlock.ConnectionKeeper.init/1","type":"function"},{"doc":"","ref":"Redlock.ConnectionKeeper.html#start_link/1","title":"Redlock.ConnectionKeeper.start_link/1","type":"function"},{"doc":"","ref":"Redlock.Executor.html","title":"Redlock.Executor","type":"module"},{"doc":"","ref":"Redlock.Executor.html#lock/2","title":"Redlock.Executor.lock/2","type":"function"},{"doc":"","ref":"Redlock.Executor.html#unlock/2","title":"Redlock.Executor.unlock/2","type":"function"},{"doc":"","ref":"Redlock.Executor.html#unlock_on_node/3","title":"Redlock.Executor.unlock_on_node/3","type":"function"},{"doc":"","ref":"Redlock.NodeChooser.html","title":"Redlock.NodeChooser","type":"module"},{"doc":"","ref":"Redlock.NodeChooser.html#choose/1","title":"Redlock.NodeChooser.choose/1","type":"function"},{"doc":"","ref":"Redlock.NodeChooser.html#init/1","title":"Redlock.NodeChooser.init/1","type":"function"},{"doc":"","ref":"Redlock.NodeChooser.Store.html","title":"Redlock.NodeChooser.Store","type":"behaviour"},{"doc":"","ref":"Redlock.NodeChooser.Store.html#c:choose/2","title":"Redlock.NodeChooser.Store.choose/2","type":"callback"},{"doc":"","ref":"Redlock.NodeChooser.Store.html#c:new/1","title":"Redlock.NodeChooser.Store.new/1","type":"callback"},{"doc":"","ref":"Redlock.NodeChooser.Store.HashRing.html","title":"Redlock.NodeChooser.Store.HashRing","type":"module"},{"doc":"","ref":"Redlock.NodeChooser.Store.SingleNode.html","title":"Redlock.NodeChooser.Store.SingleNode","type":"module"},{"doc":"","ref":"Redlock.NodeSupervisor.html","title":"Redlock.NodeSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Redlock.NodeSupervisor.html#child_spec/1","title":"Redlock.NodeSupervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"Redlock.NodeSupervisor.html#init/1","title":"Redlock.NodeSupervisor.init/1","type":"function"},{"doc":"","ref":"Redlock.NodeSupervisor.html#start_link/1","title":"Redlock.NodeSupervisor.start_link/1","type":"function"},{"doc":"","ref":"Redlock.Supervisor.html","title":"Redlock.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Redlock.Supervisor.html#child_spec/1","title":"Redlock.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"Redlock.Supervisor.html#init/1","title":"Redlock.Supervisor.init/1","type":"function"},{"doc":"","ref":"Redlock.Supervisor.html#start_link/1","title":"Redlock.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"Redlock.Util.html","title":"Redlock.Util","type":"module"},{"doc":"","ref":"Redlock.Util.html#calc_backoff/3","title":"Redlock.Util.calc_backoff/3","type":"function"},{"doc":"","ref":"Redlock.Util.html#now/0","title":"Redlock.Util.now/0","type":"function"},{"doc":"","ref":"Redlock.Util.html#random_value/0","title":"Redlock.Util.random_value/0","type":"function"}]